EDIT - bug #6311

Refactor IdentifiableEntity.compareTo method
01/05/2017 03:22 PM - Andreas Mdller

Status: Rejected Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 0%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 4.6

Severity: normal Found in Version:

Description

The IdentifiableEntity.compareTo method needs to be updated.

First of all | added the test of equality of the uuids.

Next step would be the problem if the name of two taxa is the same and the sec is the same (for example both taxa don't have a sec
ref) the method would return 0, but this should happen only if the taxa are really equal. Normaly this should not happen but may be

the last comparison should be a comparison of the created or updated date?

Related issues:
Related to EDIT - feature request #922: Implement compareTo method in Identif...
Copied from EDIT - task #4232: Check all Comparators for fulfilling the Compa...

Closed
Closed

Associated revisions

Revision dfc40f67 - 02/02/2017 03:00 PM - Andreas Miiller

fix #6311 move compareToEntity method to TaxonName and TaxonBase classes and refactor

Revision 44e2abe8 - 02/02/2017 04:05 PM - Andreas Miiller

ref #6311 further refactoring for compareToEntity

Revision ae3b8a5d - 02/02/2017 04:35 PM - Andreas Miiller
ref #922 and #6311 javadoc

History

#1 - 01/05/2017 03:22 PM - Andreas Miiller
- Copied from task #4232: Check all Comparators for fulfilling the Comparator contract added

#2 - 02/02/2017 01:27 PM - Andreas Miiller
- Status changed from New to In Progress
- Assignee changed from Katja Luther to Andreas Mdiller

- Target version changed from Reviewed Next Major Release to Release 4.6

#3 - 02/02/2017 03:00 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|dfc40f673035647f6af03097229edd1e7712222.

#4 - 02/02/2017 04:13 PM - Andreas Miiller

- Related to feature request #922: Implement compareTo method in IdentifiableEntity properly added

#5 - 02/02/2017 04:30 PM - Andreas Miiller
- Status changed from Resolved to In Progress

- Assignee changed from Andreas Miiller to Katja Luther

03/20/2024

1/2



https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/dfc40f673035647ff6af03097229edd1e7712222

- % Done changed from 50 to 0

The 2 fixes dfc40f67 and 44e2abe8 primarily fixed #922 and not THIS ticket.

However, during this process we realized that IdentifiableEntity.compareTo does not implement Comparable.compareTo and therefore does not
necessarily need to fulfill its contract.

Also with the refactoring into both subclasses using the uuid as final decision is critical as TaxonBase.compareToTaxon uses
TaxonNameBase.compareToName now and expects a 0 result if the names are equal on the cache level.

Smae applies for the mentioned requirement that compareToX should never return 0 and use e.g. date instead for sorting. Defined sorting with no
equalness we should leave to Comparators and Comparable.compareTo. Here, users of the method sometimes even expect return value 0.

Therefore | suggest that we should close this ticket as won't fix or maybe better we still include a better handling for protected titleCaches in case of
TaxonBase but leave the rest as it is.

#6 - 02/07/2017 11:48 AM - Katja Luther
- Status changed from In Progress to Rejected

- Assignee changed from Katja Luther to Andreas Mdiller

Close the ticket as we moved the methods to TaxonNameBase and TaxonBase and the compareToX methods do not implement the
Comparable.compareTo method.

03/20/2024 22


https://dev.e-taxonomy.eu/redmine/issues/922
http://www.tcpdf.org

